(**************************************************************************)
(*                       Insertion_Specifications.v                       *)
(*                                                                        *)
(*   Spcifications utiliss pour la preuve de la fonction insertion      *)
(*                                                                        *)
(* Nicolas Magaud July 1998                                               *)
(**************************************************************************)

Require Export Sorted.

Require ZArith.
Require ProgWf.

(* une relation d'ordre sur les boolens *)

Definition Zbool : bool -> bool -> Prop :=
   [b:bool][b':bool] Cases b b'  of
                                true false => True
                             |  _     _    => False
                    end.

(* l'ordre lexicographique sur les couples (boolen,entier relatif positif) *)

Definition R : bool*Z -> bool*Z -> Prop :=
   [u:(bool*Z)][u':(bool*Z)] 
        Cases u u' of
              (b,j) (b',j') => (Zbool b b')\/((b=b')/\(Zwf `0` j j'))
        end.

(* les diffrents cas couverts par l'invariant de boucle *)

Definition global_inv := [N:Z][A:(array N Z)][j:Z][n:Z][v:Z][b:bool]
  (`0<j<n` ->
      (  (sorted_array A `0` `j-1`)   
      /\ (sorted_array A `j` `n`)
      /\ (Zle A#[`j-1`] A#[`j+1`])
      /\ (Zle v A#[j])
      /\ ((b=true) -> (Zle A#[`j-1`] v))
      )
  ).

Definition inv_0 := [N:Z][A:(array N Z)][j:Z][n:Z][v:Z]
   (`j=0` ->
      (  (sorted_array A j `n`)
      /\ (Zle v A#[j])
      )
   ).
 
Definition inv_n := [N:Z][A:(array N Z)][j:Z][n:Z][v:Z][b:bool]
   (`j=n` ->
      (  (sorted_array A `0` `j-1`)
      /\ (Zle v A#[j])
      /\ ((b=true) -> (Zle A#[`j-1`] v))
      )
   ).





